summaryrefslogtreecommitdiff
path: root/tests/common
diff options
context:
space:
mode:
Diffstat (limited to 'tests/common')
-rw-r--r--tests/common66
1 files changed, 63 insertions, 3 deletions
diff --git a/tests/common b/tests/common
index eb525a4d..734cd171 100644
--- a/tests/common
+++ b/tests/common
@@ -236,6 +236,58 @@ run_mustfail()
fi
}
+# The first parameter is error message to print if it fails, just like
+# run_must_fail().
+# NOTE: we don't use pipefail to avoid disturbing other script, so here we
+# use a temporary output file.
+# So it doesn't support pipeline in the @cmd
+run_mustfail_stdout()
+{
+ local spec
+ local ins
+ local cmd
+ local msg
+ local ret
+ local tmp_output
+
+ tmp_output=$(mktemp --tmpdir btrfs-progs-test--mustfail-stdtout.XXXXXX)
+
+ msg="$1"
+ shift
+
+ if _is_file_or_command "$msg"; then
+ echo "ASSERTION FAIL: 1st argument of run_mustfail_stdout must be a message"
+ exit 1
+ fi
+
+ ins=$(_get_spec_ins "$@")
+ spec=$(($ins-1))
+ cmd=$(eval echo "\${$spec}")
+ spec=$(_cmd_spec "${@:$spec}")
+ set -- "${@:1:$(($ins-1))}" $spec "${@: $ins}"
+ echo "############### $@" >> "$RESULTS" 2>&1
+ if [[ $TEST_LOG =~ tty ]]; then echo "CMD(mustfail): $@" > /dev/tty; fi
+ if [ "$1" = 'root_helper' ]; then
+ "$@" 2>&1 > "$tmp_output"
+ else
+ $INSTRUMENT "$@" 2>&1 > "$tmp_output"
+ fi
+ ret=$?
+
+ cat "$tmp_output" >> "$RESULTS"
+ cat "$tmp_output"
+ rm "$tmp_output"
+
+ if [ "$ret" != 0 ]; then
+ echo "failed (expected): $@" >> "$RESULTS"
+ return 0
+ else
+ echo "succeeded (unexpected!): $@" >> "$RESULTS"
+ _fail "unexpected success: $msg"
+ return 1
+ fi
+}
+
check_prereq()
{
if ! [ -f "$TOP/$1" ]; then
@@ -389,8 +441,12 @@ prepare_test_dev()
# num[K/M/G/T...]
local size="$1"
- [[ "$TEST_DEV" ]] && return
[[ "$size" ]] || size='2G'
+ # Still truncate it to new size
+ if [ -n "$TEST_DEV" ]; then
+ truncate -s "$size" "$TEST_DEV"
+ return;
+ fi
echo "\$TEST_DEV not given, use $TOP/test/test.img as fallback" >> \
"$RESULTS"
@@ -428,8 +484,12 @@ run_check_umount_test_dev()
check_kernel_support()
{
if ! grep -iq 'btrfs' /proc/filesystems; then
- echo "WARNING: btrfs filesystem not listed in /proc/filesystems, some tests might fail"
- return 1
+ run_check $SUDO_HELPER modprobe btrfs
+ if ! grep -iq 'btrfs' /proc/filesystems; then
+ echo \
+"WARNING: btrfs filesystem not found in /proc/filesystems, some tests might fail"
+ return 1
+ fi
fi
return 0
}